# About Code Coverage

Use the Code Coverage package with the **Test Runner** to gather and present test coverage information. When you run your tests with code coverage enabled you can see exactly which lines of your code are executed when the tests run in addition to whether the tests passed or failed.

Once a test run has completed, the Code Coverage package will generate an HTML coverage report showing which lines of your code are covered by tests. Code Coverage currently supports **EditMode** and **PlayMode** tests. It also allows you to track the code coverage changes through time.

Additionally, the Code Coverage package offers a **Coverage Recording** feature which allows capturing coverage data on demand, in case you do not have tests in your project or doing manual testing.

The Code Coverage package is available as a released package via the Package Manager for Unity 2019.3 and above.

For more information see the [Code Coverage package documentation](https://docs.unity3d.com/Packages/com.unity.testtools.codecoverage@latest).

|CI Status|
|:---|
|![ReleaseBadge](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/candidates-badge.svg) ![ReleaseBadge](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/release-badge.svg)|
|[![](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/build-badge.svg?branch=master&testWorkflow=package-isolation)](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/build-info?branch=master&testWorkflow=package-isolation) [![](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/warnings-badge.svg?branch=master)](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/warnings-info?branch=master)|
|[![](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/dependencies-badge.svg?branch=master&testWorkflow=updated-dependencies)](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/dependencies-info?branch=master&testWorkflow=updated-dependencies) [![](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/dependants-badge.svg)](https://badges.cds.internal.unity3d.com/packages/com.unity.testtools.codecoverage/dependants-info)|
