# About Visual Scripting

Visual Scripting enables you to create logic for games or applications without writing code. Visual Scripting uses visual, node-based graphs, which both programmers and non-programmers use to design final logic or create prototypes. Visual Scripting also has an API that programmers use for more advanced tasks, or for creating custom nodes for other team members.

Visual Scripting uses graphical elements, which represent functions, operators, or variables. You can then connect these nodes from their ports by using edges. Instead of having to write code line by line, you do everything visually.

## Installation

From Unity Editor version 2021.1 onward, Visual Scripting is installed by default as a package. For more information on packages, see the [Packages section in the Unity User Manual](https://docs.unity3d.com/Manual/PackagesList.html).

For earlier versions of Unity, including 2019 LTS and 2020 LTS, you will need to install it via the [Unity Asset Store](https://assetstore.unity.com/packages/tools/visual-bolt-163802).

## Configuring visual scripting

Get started by [configuring your project settings](vs-configuration.md) and [configuring your preferences](vs-set-preferences.md).

## Choose a control scheme

Learn the common keyboard shortcuts and [choose a control scheme](vs-control-schemes.md) that suits your needs.

## Updating visual scripting

Learn how to [update visual scripting](vs-update.md) and [create and restore backups](vs-create-restore-backups.md).

## System Requirements

Visual scripting has no external dependencies.



